#include "BITON.CH"
#include "..\ACHOICE.CH"
#include "..\INKEY.CH"

*********************************
* O_dbu21.prg    
*
* File Handling (Tables)
*********************************
Save Screen to Bit_scr1
*********************************
* Set up Arrays & scroll Windows
* for user listing
*================================
*********************************
* Arrays
*--------------------------------
* Tabl_crea     = Table Creators
* Tname         = Table Name
* A_dbsize      = Size of Field on Database
* A_flsize      = Fetch Size of Field
* A_fltype      = Data type
* A_flname      = Field Name
* A_iname       = Index Name
* A_icol        = Index Column
* A_sname       = Space Name
* A_ikey        = Indexed Tables
* A_tindex      = Index Tables 
* A_ttype       = Field Bind Types
*--------------------------------
Declare  A_dbsize[1], A_flsize[1],A_flname[1],;
         A_iname[1],A_ikey[1],A_icol[1],A_sname[1],;
         A_tindex[1], A_ttype[1]

A_tindex[1] := Space(30)
A_ttype[1]  := 'C'
*================================
* Memvars
crea_cnt  := Space(22)
crea_cnt1 := 0
cnt       := 0
crea_elem := 0                                    && ---- Number of elems

icnt      := Space(22)
icnt1     := 0

ikey      := .F.

*--------------------------------
* Windows
*--------------------------------
* Table Window
Setcolor(p_colshade)
@ 03,02 Clear to 15,36
Setcolor(p_colawind)
@ 02,01 Clear To 14,35
@ 02,01 To 14,35
@ 02,14 Say Chr(180)+'Tables'+Chr(195)
Scroll(03,02,13,34,0)

* Creator Window
Setcolor(p_colshade)
@ 03,41 Clear to 5,76
Setcolor(p_colawind)
@ 02,40 Clear To 04,75
@ 02,40 To 04,75
@ 02,53 Say Chr(180)+'Creator'+Chr(195)

* Index Indicator Window
Setcolor(p_colshade)
@ 07,41 Clear to 09,76
Setcolor(p_colawind)
@ 06,40 Clear To 08,75
@ 06,40 To 08,75
@ 06,54 Say Chr(180)+'Index'+Chr(195)

Setcolor(p_colawind)
@ 16,01 Clear To 21,35
@ 16,01 To 21,35
@ 16,11 Say Chr(180)+'Key Options'+Chr(195)
@ 17,02 Say 'Esc - Back Out'
@ 18,02 Say CHR(24)+' Up'
@ 19,02 Say Chr(25)+' Down'
@ 17,19 Say 'F4  - Browse    '
@ 18,19 Say 'Ins - Add Table '
@ 19,19 Say 'Del - Drop Table'
@ 20,02 Say '<cr> - Struc'

***********************************
Do while .t.
  *=====================*
  * Set up Table Array  *
  *=====================*
  Bit_status('......Loading Table Information')

  *------------------------
  * Get Creators from 
  * Table_audit
  *------------------------
  SQLEXEC SELECT FOR 1 DISTINCT COUNT(&Audit_col2) FROM &Audit_table ; 
                                             WHERE &Audit_col3 = 'TABLE';
                                             Into @crea_cnt
  O_orclpnum(crea_cnt, @crea_cnt1)

  crea_elem := crea_cnt1

  Declare Tabl_crea[crea_cnt1], Tname[crea_cnt1]

  cnt := 1
  Do while cnt <= Len(Tabl_crea)
     Tabl_crea[cnt] := Space(30)
     Tname[cnt]     := Space(30)
     cnt++
  Enddo

  If crea_cnt1 == 1
     tmp := Space(30)
     tmp1:= Space(30)

     SQLEXEC SELECT FOR 1 &Audit_col1, &Audit_col2 ; 
                          FROM &Audit_table ;
                          WHERE &Audit_col3 = 'TABLE';
                          ORDER BY &Audit_col2 ;
                          INTO @tmp, @Tmp1
     Tabl_crea[1] := tmp
     Tname[1]     := tmp1
  Else
     SQLEXEC SELECT FOR crea_cnt1 &Audit_col1, &Audit_col2 ; 
                                  FROM &Audit_table ; 
                                  WHERE &Audit_col3 = 'TABLE';
                                  ORDER BY &Audit_col2 ;
                                  INTO Tabl_crea, Tname
  Endif

 /**************************
  Get Table Names with 
  Indexes
  **************************/
  SQLEXEC SELECT FOR 1 DISTINCT COUNT(&Index_col1) FROM &Index_table;
                                             INTO @crea_cnt

  O_orclpnum(crea_cnt, @crea_cnt1)


  If crea_cnt1 <> 0

     ikey := .T.

     Declare A_ikey[crea_cnt1]

     cnt := 1
     Do while cnt <= Len(A_ikey)
        A_ikey[cnt] := Space(30)
        cnt++
     Enddo


     If crea_cnt1 == 1
        tmp := Space(30)
        SQLEXEC SELECT FOR 1 DISTINCT &Index_col1 FROM &Index_table ;
                                            INTO @tmp
        A_ikey[1] := tmp
        Rele tmp

     Else
        SQLEXEC SELECT FOR crea_cnt1 DISTINCT &Index_col1 FROM &Index_table ;
                                                    INTO A_ikey

     Endif

  Else

     ikey := .F.

  Endif

  /**********************************
   Get Space Definitions
   **********************************/
  SQLEXEC SELECT FOR 1 DISTINCT COUNT(&space_col1) FROM &Space_table ; 
                                             Into @crea_cnt
  O_orclpnum(crea_cnt, @crea_cnt1)

  Declare A_Sname[crea_cnt1]
  AFill(A_Sname,Space(30))

  SQLEXEC SELECT FOR crea_cnt1 DISTINCT &Space_Col1 FROM &Space_table ;
                                              Into A_Sname

  /****************** End Load ************************/

  Bit_status()

  Setcolor(p_colawind)
  @ 03,42 Say Tabl_crea[1] Picture 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'

  If ikey
     If Ascan(A_ikey,Alltrim(Tname[1])) <> 0
        SetColor(p_colawind)
        @ 20,15 Say Chr(26)+' See Index'
        @ 07,42 Say 'Indexes Exist      '
     Else
        @ 20,15 Say '           '
        @ 07,42 Say 'No Indexes on Table'
     Endif
  Else
     @ 20,15 Say '           '
     @ 07,42 Say 'No Indexes on Table'
  Endif
   
  cnt := 1

  While .t.
    cnt := Achoice(03,02,13,34,Tname,.T.,"Tbl_choic",cnt)

    If cnt > crea_elem
       cnt := crea_elem
    Endif   

	If cnt == 0 
       Exit
    Endif

  Enddo


***********************************
Restore Screen from Bit_scr1

Return
Enddo
*****************************************************
* Functions
* ---------------------------------------------------
* Tbl_choic()        -- Table Achoice Function
* Tbl_show()         -- Table Structure
* Indx_show(elem)    -- Show Indexes on Table
* Col_show(elem)     -- Show Columns on Table
* Tabl_ins()         -- Add Table
* Tabl_del()         -- Drop Table
*****************************************************
Function Tbl_choic(ac_mode,ac_elem,ac_row)

_ret_val := 0

Do Case
Case ac_mode == AC_IDLE .Or. ac_mode == AC_NOITEM ;
                .or. ac_mode == AC_PASTTOP .Or. ac_mode == AC_PASTEND

   _ret_val := AC_CONT

  @ 03,42 Say Tabl_crea[ac_elem] Picture 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'

  If ikey
     If Ascan(A_ikey,Alltrim(Tname[ac_elem])) <> 0
        SetColor(p_colawind)
        @ 20,15 Say Chr(26)+' See Index'
        @ 07,42 Say 'Indexes Exist      '
     Else
        @ 20,15 Say '           '
        @ 07,42 Say 'No Indexes on Table'
     Endif
  Else
     @ 20,15 Say '           '
     @ 07,42 Say 'No Indexes on Table'
  Endif

Other

  Do Case
  Case Lastkey() == K_ESC
     _ret_val := AC_ABORT

  Case Lastkey() == K_ENTER        /* Show  Structure */
     inkey()

     Tbl_show(ac_elem)
     
     _ret_val := AC_CONT

  Case Lastkey() == K_RIGHT

     /* Check for Index */

     If Ascan(A_ikey,Alltrim(Tname[ac_elem])) <> 0
        Indx_show(ac_elem)
     Endif

     _ret_val := AC_CONT

  Case Lastkey() == K_INS          && ---- Add a Table

     _ret_val := Table_ins()
     _ret_val := crea_elem + 1

  Case Lastkey() == K_DEL          && ---- Delete a Table

     _ret_val := Table_del(ac_elem)
     _ret_val := crea_elem + 1


  Case Lastkey() == K_F4
     m_table := ALLTRIM(Tabl_crea[ac_elem])+'.'+ALLTRIM(Tname[ac_elem])
     TV_browse("&m_table",01,01,21,79)

     _ret_val := AC_CONT

  Other                            && ---- First Letter Pressed 
     _ret_val := AC_GOTO

  Endcase


Endcase
     
Return _ret_val

*****************************************************
Function Tbl_show(tb_elem)
*****************************************************
m_numfld  := 0
p_key2    := 0

Bit_status('Wait')
tab_name := ALLTRIM(Tabl_crea[tb_elem])+'.'+ALLTRIM(Tname[tb_elem])

SQLEXEC DESCRIBE NUMBER OF FIELDS IN TABLE &tab_name Into m_numfld

If m_numfld == 0
   Return .T.
Endif

If Type("A_dbsize") != "U"
   Rele A_dbsize, A_flsize, A_flname, A_fltype
Endif

Declare A_dbsize[m_numfld], A_flsize[m_numfld], A_flname[m_numfld],;
        A_fltype[m_numfld]

Afill(A_dbsize,0)
Afill(A_flsize,0)
Afill(A_fltype," ")
Afill(A_flname,Space(20))


SQLEXEC DESCRIBE TABLE &tab_name Into A_dbsize, A_flsize, A_fltype, A_flname

Bit_status()

*========================
* All Info Here
*========================

Save screen to Bit_scr2

Setcolor(p_colshade)
@ 08,09 Clear to 20,53
Setcolor(p_colawind)
@ 07,10 Clear To 19,54
@ 07,10 To 19,54
@ 07,25 Say Chr(180)+'Description'+Chr(195)
Scroll(10,12,18,53,0)

@ 08,11 Say 'Field Name'
@ 08,34 Say 'Data'
@ 08,41 Say 'Fetch'
@ 08,49 Say 'Field'
@ 09,34 Say 'Length'
@ 09,41 Say 'Length'
@ 09,49 Say 'Type'

For cnt := 1 To 9
   @ 10+(cnt-1),13 Say A_flname[cnt] Picture 'XXXXXXXXXXXXXXXXXXXX'
   @ 10+(cnt-1),34 Say A_dbsize[cnt] Picture '9999'
   @ 10+(cnt-1),41 Say A_flsize[cnt] Picture '9999'
   @ 10+(cnt-1),49 Say A_fltype[cnt] Picture 'X'
   If cnt == Len(A_dbsize)
      Exit
   Endif
Next

t_row := 10                                        && ---- Temp Row
cnt := 1

Do While .T.

  @ t_row,12 Say  '>'
  p_key2 := Inkey()

  Do Case
  Case p_key2 == 0
     Loop
  Case p_key2 == K_ESC
     Exit

  Case p_key2 == K_DOWN

     cnt++
     t_row++

     If cnt > Len(A_dbsize)
        cnt--
        t_row--
        Loop
     Endif


     If t_row > 18
        Scroll(10,12,18,53,1)
        t_row := 18
        @ t_row-1,12 Say ' '
     Else
        @ t_row-1,12 Say ' '                 /* Clear Arrow */
     Endif

  Case p_key2 == K_UP

     cnt--
     t_row--

     If cnt < 1
        cnt++
        t_row++
        Loop
     Endif


     If t_row < 10
        Scroll(10,12,18,53,-1)
        @ t_row+2,12 Say ' '                 /* Clear Arrow */
        t_row := 10
     Else
        @ t_row+1,12 Say ' '                 /* Clear Arrow */
     Endif
       
  Other
 
     Loop
  Endcase

  @ t_row,13 Say A_flname[cnt] Picture 'XXXXXXXXXXXXXXXXXXXX'
  @ t_row,34 Say A_dbsize[cnt] Picture '9999'
  @ t_row,41 Say A_flsize[cnt] Picture '9999'
  @ t_row,49 Say A_fltype[cnt] Picture 'X'
  @ t_row,12 Say '>'

Enddo



Rele A_dbsize, A_flsize, A_flname, A_fltype

Restore Screen from Bit_scr2
Return .T.

*****************************************************
Function Indx_show(tbl_elem)
*****************************************************
tab_name := ALLTRIM(Tname[tbl_elem])
tab_crea := ALLTRIM(Tabl_crea[tbl_elem])

icnt     := SPACE(22)
icnt1    := 0
i2cnt    := 1

/************************
 Find Number of Indexes
 ************************/
Bit_status('Wait')

SQLEXEC SELECT FOR 1 DISTINCT COUNT(&Index_col2) ;
                              FROM &Index_table ;
                              WHERE &Index_col1   = '&tab_name' ;
                              INTO @icnt

O_orclpnum(icnt, @icnt1)

If icnt1 == 0
   Return .T.
Endif

/*******************************/
Save Screen to Bit_scr3

Declare A_Iname[icnt1], A_Icrea[icnt1] , A_Iorder[icnt1], A_Itype[icnt1]

cnt1 := 1

While cnt1 <= Len(A_iname)
   A_Iname[cnt1] := Space(30)
   A_Icrea[cnt1] := Space(30)
   A_Iorder[cnt1]:= Space(4)
   A_Itype[cnt1] := Space(10)
   cnt1++
Enddo

If icnt1 == 1
   i_name := Space(30)
   i_crea := Space(30)
   i_order:= Space(4)
   i_type := Space(10)

   SQLEXEC SELECT FOR icnt1 DISTINCT &Index_col2, &Index_col3, &Index_col4,;
                                     &Index_col5 ; 
                                 FROM &Index_table ;
                                 WHERE &Index_col1   = '&tab_name' ;
                                 INTO @i_name,@i_crea,@i_order,@i_type

    A_Iname[1] := i_name 
    A_Icrea[1] := i_crea
    A_Iorder[1]:= i_order
    A_Itype[1] := i_type

    Rele i_name,i_crea, i_order, i_type


Else

   SQLEXEC SELECT FOR icnt1 DISTINCT &Index_col2, &Index_col3, &Index_col4,;
                                     &Index_col5 ; 
                                 FROM &Index_table ;
                                 WHERE &Index_col1 = '&tab_name' ;
                                 INTO A_iname, A_icrea, A_iorder, A_itype
   Do While Ascan(A_Iname,Space(30)) <> 0
      _elem := Ascan(A_Iname,Space(30))
      Adel(A_iname,_elem)
      Adel(A_icrea,_elem)
      Adel(A_iorder,_elem)
      Adel(A_Itype,_elem)
      icnt1--
   Enddo

Endif



Bit_status()
/*********************************
 Index Headers Read
 *********************************/

/* Display Box  */
* Index Indicator Window
Setcolor(p_colshade)
@ 07,36 Clear to 20,76
Setcolor(p_colawind)
@ 06,35 Clear To 19,75
@ 06,35 To 19,75
@ 06,49 Say Chr(180)+'Index'+Chr(195)

i2cnt := 1

@ 07,36 Say 'Index:       of:'
@ 07,43 Say i2cnt Picture '999'
@ 07,53 Say icnt1 Picture '999'

@ 08,36 Say 'Name   :'
@ 09,36 Say 'Creator:'
@ 10,36 Say 'Asc/Des:'
@ 11,36 Say 'Type   :'
@ 12,36 To 12,74
/*************************
 icnt1  == Number of Indexes
 *************************/


 Do While .t.

   /************************************
    Display Header Details
    ************************************/
    @ 13,36 Clear to 18,66
    @ 07,44 Say i2cnt  Picture '999'
    @ 08,44 Say A_Iname[i2cnt]  Picture 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
    @ 09,44 Say A_Icrea[i2cnt]  Picture 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
    @ 10,44 Say A_Iorder[i2cnt] Picture 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
    @ 11,44 Say A_Itype[i2cnt]  Picture 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'


   /* Read Info */
    tmp = Alltrim(A_Iname[i2cnt])

    SQLEXEC SELECT FOR 1 COUNT(&Index_col6) FROM &Index_table ;
                         WHERE &Index_col2 = '&tmp' ;
                         INTO @crea_cnt

    O_orclpnum(crea_cnt, @crea_cnt1)

    If Type("A_Icol") != 'U'
       Rele A_Icol
    Endif

    Declare A_icol[crea_cnt1]

    Afill(A_icol, Space(30))

    If crea_cnt1 == 1
       tmp_num := SPACE(30)
       SQLEXEC SELECT FOR 1 &Index_col6 FROM &Index_table ;
                            WHERE &Index_col2 = '&tmp' ;
                            INTO @tmp_num
       A_icol[1] := tmp_num
       Rele tmp_num
    Else
       SQLEXEC SELECT FOR crea_cnt1 &Index_col6 FROM &Index_table ;
                                    WHERE &Index_col2 = '&tmp' ;
                                    INTO A_icol
    Endif

    Do While Ascan(A_Icol,Space(30)) <> 0
       _elem := Ascan(A_Icol,Space(30))
       Adel(A_Icol,_elem)
    Enddo

    If A_Icol[1] != NIL

       For i = 1 To 6
          @ 13+(i-1), 37 Say A_icol[i] Picture 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'

          If i == Len(A_icol) .or. A_icol[i] == NIL
             Exit
          Endif
       Next

    Endif

    p2key := 0

 /* Process Keys  */
 /* Main Header   */

    Do while .t.

       p2key := inkey()

       Do case
       Case p2key == 0
          Loop

       Case p2key == K_ESC
          Exit

       Case p2key == K_DOWN

          If i2cnt == Len(A_Iname) 
             i2cnt := 1                       
          Else
             i2cnt++
             If A_iname[i2cnt] == NIL
                i2cnt--
             Endif
          Endif

          Exit

       Case p2key == K_UP                  
   
          If i2cnt == 1
             i2cnt := Len(A_iname)    
      
             If A_iname[i2cnt] == NIL .And. i2cnt <> 1
                i2cnt--
             Endif

          Else
             i2cnt--

             If A_iname[i2cnt] == NIL
                i2cnt++ 
             Endif

          Endif
                                              
          Exit

       Case p2key == K_PGDN
          inkey()
          col_show()
          Loop

       Endcase

    Enddo                      /* Main Header */



    If p2key == K_ESC
       Exit
    Endif

 Enddo                        /* Main Routine */

 /* Clean up  */






/******************************/

Restore Screen From Bit_scr3
Return .T.
*****************************************************
Function col_show(tbl_elem)
*****************************************************
t_row := 13
t_cnt := 1

Do While .T.

  @ t_row,36 Say  '>'
  p_key2 := Inkey()

  Do Case
  Case p_key2 == 0
     Loop
  Case p_key2 == K_ESC
     
     Exit

  Case p_key2 == K_PGUP
     Exit

  Case p_key2 == K_DOWN

     t_cnt++
     t_row++

     If t_cnt > Len(A_icol)
        t_cnt--
        t_row--
        Loop
     Endif


     If t_row > 18
        Scroll(13,37,18,67,1)
        t_row := 18
        @ t_row-1,36 Say ' '
     Else
        @ t_row-1,36 Say ' '                 /* Clear Arrow */
     Endif

  Case p_key2 == K_UP

     t_cnt--
     t_row--

     If t_cnt < 1
        t_cnt++
        t_row++
        Loop
     Endif


     If t_row < 13
        Scroll(13,37,18,67,-1)
        @ t_row+2,36 Say ' '                 /* Clear Arrow */
        t_row := 13
     Else
        @ t_row+1,36 Say ' '                 /* Clear Arrow */
     Endif
       
  Other
 
     Loop
  Endcase

  @ t_row,36 Say '>'
  @ t_row,37 Say A_icol[t_cnt] Picture 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'

Enddo

@ t_row,36 Say  ' '
Return .T.
*****************************************************
Function Table_ins()
*****************************************************
* Add a Table, to Table arrays
*****************************************************
Save Screen To Bit_scr3

t_table := Space(30)
t_field := Space(30)
t_type  := ' '
t_int   := Space(4)
t_mant  := SPace(4)
t_space := Space(30)
t_null  := 'Y'
t_fldef := NIL
t_row   := 9
tab_col := Setcolor()
t_elem := 1
*====================================================
Setcolor(p_colshade)
@ 05,21 Clear to 21,61
Setcolor(p_colawind)
@ 04,20 Clear To 20,60
@ 04,20 To 20,60
@ 04,34 Say Chr(180)+'Add Table'+Chr(195)
@ 05,21 Say 'Table:'
@ 06,21 Say 'Field'
@ 06,35 Say 'Type'
@ 06,40 Say 'Length'
@ 06,50 Say 'Null (Y/N)'
@ 07,21 to 07,25
@ 07,35 to 07,38
@ 07,40 to 07,45
@ 07,50 to 07,59
@ 19,21 Say 'Space:'
*---------------------------------------------------
Setcolor(p_colwinp)
@ 05,28 Get t_table Picture '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
Read

/* Check for Table Later */

Do While .t.
   If t_row > 18
      Scroll(09,21,18,59,1)
      t_row := 18
   Endif

   @ t_row,21 Get t_field Picture '@S10'
   @ t_row,36 Get t_type Picture '!' Valid t_type == 'C'.or.t_type == 'D'.or.;
                                           t_type == 'N'.or. t_type == 'L'

   Read

   If Lastkey() == K_ESC
      Exit
   Endif

   If t_type != 'D' .and. t_type != 'L'
      @ t_row,40 Get t_int Picture '9999'

      If t_type != 'C'
         @ t_row,44 Say ','
         @ t_row,45 Get t_mant Picture '9999'
      Endif

      Read
   Endif

   @ t_row, 55 Get t_null Picture 'Y'
   Read

   If Lastkey() == K_ESC
      Exit
   Endif

   If t_field == SPACE(30)
      o_errwrite(-5,"Invalid Field Name")
      Bit_error()
      Loop
   Endif

   /* Build Input Field Def */
   If t_fldef != NIL
      t_fldef := t_fldef + ','+Alltrim(t_field)
   Else
      t_fldef := Alltrim(t_field)
   Endif

   Do Case
   Case t_type == 'C'
      t_fldef := t_fldef+' CHAR('
   Case t_type == 'N'
      t_fldef := t_fldef+' NUMBER('
   Case t_type == 'D'
      t_fldef := t_fldef+' DATE'
   Case t_type == 'L'
      t_fldef := t_fldef+' LONG'
   Other
      t_fldef := t_fldef+' CHAR('
   Endcase

   If t_type != 'D' .and. t_type != 'L'
      t_fldef := t_fldef + Alltrim(t_int)

      If t_type != 'C' .And. Val(t_mant) != 0
         t_fldef := t_fldef +','+Alltrim(t_mant)
      Endif
      t_fldef := t_fldef + ')'
   Endif

   If t_null == 'N'
      t_fldef := t_fldef +' NOT NULL'
   Endif

   t_field := Space(30)
   t_type  := ' '
   t_int   := Space(4)
   t_mant  := SPace(4)
   t_null  := 'Y'

   t_row++
Enddo

/* Space Definition */


Bit_scr4 := SaveScreen(6,25,20,59)


Setcolor(p_colshade)
@ 07,26 Clear to 15,59
Setcolor(p_colawind)
@ 06,25 Clear To 14,57
@ 06,25 To 14,57
@ 06,37 Say Chr(180)+'Space'+Chr(195)


cnt := 1
While .t.

   cnt := Achoice(07,26,13,56,A_Sname,.T.,,cnt)

   If cnt != 0 
      Exit
   Endif

Enddo

t_space := A_Sname[cnt]
RestScreen(6,25,20,59,Bit_scr4)


@ 19,28 Say t_space Picture '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'

/***************************
 Check O.K.
 ***************************/
BIt_scr4 := Savescreen(15,10,18,32)
Setcolor(p_colerrbox)
@ 15,10 Clear To 18,32
@ 15,10 To 18,32 Double
Setcolor(p_colerrmess)

@ 16,11 Say ' Hit Enter to Create'
@ 17,12 Say '   Esc to Ignore    '

Set Cursor Off
* 
Do While .T.
   i=Inkey()
   
   Do Case
   Case i=0
      Loop
   Case i == 27 .or. i == 13
      Exit
   Other
      Loop
   Endcase
   
Enddo

Restscreen(15,10,18,32,Bit_scr4)
Rele Bit_scr4


/**************************
 Create Table
 **************************/
If i == K_ENTER

   If t_space <> Space(30)
      SQLEXEC CREATE TABLE &t_table(&t_fldef) SPACE &t_space
   Else
      SQLEXEC CREATE TABLE &t_table(&t_fldef)
   Endif

   If o_errno() != 0
      Bit_error()
   Else
      /* Add to Arrays */
      AADD(Tname,'temp')
      AADD(Tabl_crea,'temp')

      t_elem := 1

      Do While .t.

        If Tname[t_elem] == NIL
           Exit
        Endif

        If t_table < Tname[t_elem]
           Exit
        Endif

        t_elem++
      Enddo

      Ains(Tname,t_elem)
      Ains(Tabl_crea,t_elem)

      Tname[t_elem]     := t_table
      Tabl_crea[t_elem] := m_userid
      crea_elem++

   Endif

Endif

*====================================================
Restore Screen From Bit_scr3
Setcolor(tab_col)
Return t_elem

*****************************************************
Function Table_del(t_elem)
Local m_del
*****************************************************
* Delete a Table, and Table arrays
*****************************************************
tab_col  := Setcolor()
table_nm := Tname[t_elem]
m_del    := 'N'

Bit_scr3 := Savescreen(15,10,18,32)
Setcolor(p_colerrbox)
@ 15,10 Clear To 18,32
@ 15,10 To 18,32 Double
Setcolor(p_colerrmess)

If Tabl_crea[t_elem] != m_userid
   @ 16,11 Say ' Not Your Table !   '
   @ 17,12 Say '   Hit Escape       '
Else   
   @ 16,11 Say ' Hit Enter to Delete'
   @ 17,12 Say '   Esc to Ignore    '
   m_del := 'Y'
Endif

Set Cursor Off
* 
Do While .T.
   i=Inkey()
   
   Do Case
   Case i=0
      Loop
   Case i == 27 .or. i == 13
      Exit
   Other
      Loop
   Endcase
   
Enddo

Restscreen(15,10,18,32,Bit_scr3)
Rele Bit_scr3
Setcolor(p_colwinp)

If i != 27 .And. m_del == 'Y'                        /* Escape */
   SQLEXEC DROP TABLE &table_nm

   If o_errno() != 0
      Bit_error()
   Else
      /* Delete from Arrays */
      ADEL(Tname,t_elem)
      ADEL(Tabl_crea,t_elem)
      crea_elem--
      Bit_status('Table Deleted','Y')
   Endif
Endif

*====================================================
Setcolor(tab_col)

Return t_elem

*====================================================

